/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AmazonAdsConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AmazonAdsConnectorFormAllOf{}

// AmazonAdsConnectorFormAllOf struct for AmazonAdsConnectorFormAllOf
type AmazonAdsConnectorFormAllOf struct {
	// Authorizer ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Amazon Ads Profile ID
	ProfileId *string `json:"profileId,omitempty"`
	// Amazon Ads Report Category (Ad Product)
	AdProduct *string `json:"adProduct,omitempty"`
	// Amazon Ads Report Type
	ReportType *string `json:"reportType,omitempty"`
	// Amazon Ads Grouping parameter
	GroupBy []string `json:"groupBy,omitempty"`
	// Amazon Ads Time Unit
	TimeUnit *string `json:"timeUnit,omitempty"`
	// Amazon Ads Tactic
	Tactic *string `json:"tactic,omitempty"`
	// Columns
	Column []string `json:"column,omitempty"`
	// Data range expression
	DateRange *string `json:"dateRange,omitempty"`
}

// NewAmazonAdsConnectorFormAllOf instantiates a new AmazonAdsConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAmazonAdsConnectorFormAllOf() *AmazonAdsConnectorFormAllOf {
	this := AmazonAdsConnectorFormAllOf{}
	return &this
}

// NewAmazonAdsConnectorFormAllOfWithDefaults instantiates a new AmazonAdsConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAmazonAdsConnectorFormAllOfWithDefaults() *AmazonAdsConnectorFormAllOf {
	this := AmazonAdsConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *AmazonAdsConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *AmazonAdsConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetProfileId returns the ProfileId field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetProfileId() string {
	if o == nil || IsNil(o.ProfileId) {
		var ret string
		return ret
	}
	return *o.ProfileId
}

// GetProfileIdOk returns a tuple with the ProfileId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetProfileIdOk() (*string, bool) {
	if o == nil || IsNil(o.ProfileId) {
		return nil, false
	}
	return o.ProfileId, true
}

// HasProfileId returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasProfileId() bool {
	if o != nil && !IsNil(o.ProfileId) {
		return true
	}

	return false
}

// SetProfileId gets a reference to the given string and assigns it to the ProfileId field.
func (o *AmazonAdsConnectorFormAllOf) SetProfileId(v string) {
	o.ProfileId = &v
}

// GetAdProduct returns the AdProduct field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetAdProduct() string {
	if o == nil || IsNil(o.AdProduct) {
		var ret string
		return ret
	}
	return *o.AdProduct
}

// GetAdProductOk returns a tuple with the AdProduct field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetAdProductOk() (*string, bool) {
	if o == nil || IsNil(o.AdProduct) {
		return nil, false
	}
	return o.AdProduct, true
}

// HasAdProduct returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasAdProduct() bool {
	if o != nil && !IsNil(o.AdProduct) {
		return true
	}

	return false
}

// SetAdProduct gets a reference to the given string and assigns it to the AdProduct field.
func (o *AmazonAdsConnectorFormAllOf) SetAdProduct(v string) {
	o.AdProduct = &v
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *AmazonAdsConnectorFormAllOf) SetReportType(v string) {
	o.ReportType = &v
}

// GetGroupBy returns the GroupBy field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetGroupBy() []string {
	if o == nil || IsNil(o.GroupBy) {
		var ret []string
		return ret
	}
	return o.GroupBy
}

// GetGroupByOk returns a tuple with the GroupBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetGroupByOk() ([]string, bool) {
	if o == nil || IsNil(o.GroupBy) {
		return nil, false
	}
	return o.GroupBy, true
}

// HasGroupBy returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasGroupBy() bool {
	if o != nil && !IsNil(o.GroupBy) {
		return true
	}

	return false
}

// SetGroupBy gets a reference to the given []string and assigns it to the GroupBy field.
func (o *AmazonAdsConnectorFormAllOf) SetGroupBy(v []string) {
	o.GroupBy = v
}

// GetTimeUnit returns the TimeUnit field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetTimeUnit() string {
	if o == nil || IsNil(o.TimeUnit) {
		var ret string
		return ret
	}
	return *o.TimeUnit
}

// GetTimeUnitOk returns a tuple with the TimeUnit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetTimeUnitOk() (*string, bool) {
	if o == nil || IsNil(o.TimeUnit) {
		return nil, false
	}
	return o.TimeUnit, true
}

// HasTimeUnit returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasTimeUnit() bool {
	if o != nil && !IsNil(o.TimeUnit) {
		return true
	}

	return false
}

// SetTimeUnit gets a reference to the given string and assigns it to the TimeUnit field.
func (o *AmazonAdsConnectorFormAllOf) SetTimeUnit(v string) {
	o.TimeUnit = &v
}

// GetTactic returns the Tactic field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetTactic() string {
	if o == nil || IsNil(o.Tactic) {
		var ret string
		return ret
	}
	return *o.Tactic
}

// GetTacticOk returns a tuple with the Tactic field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetTacticOk() (*string, bool) {
	if o == nil || IsNil(o.Tactic) {
		return nil, false
	}
	return o.Tactic, true
}

// HasTactic returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasTactic() bool {
	if o != nil && !IsNil(o.Tactic) {
		return true
	}

	return false
}

// SetTactic gets a reference to the given string and assigns it to the Tactic field.
func (o *AmazonAdsConnectorFormAllOf) SetTactic(v string) {
	o.Tactic = &v
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetColumn() []string {
	if o == nil || IsNil(o.Column) {
		var ret []string
		return ret
	}
	return o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetColumnOk() ([]string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given []string and assigns it to the Column field.
func (o *AmazonAdsConnectorFormAllOf) SetColumn(v []string) {
	o.Column = v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *AmazonAdsConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *AmazonAdsConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *AmazonAdsConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

func (o AmazonAdsConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AmazonAdsConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ProfileId) {
		toSerialize["profileId"] = o.ProfileId
	}
	if !IsNil(o.AdProduct) {
		toSerialize["adProduct"] = o.AdProduct
	}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.GroupBy) {
		toSerialize["groupBy"] = o.GroupBy
	}
	if !IsNil(o.TimeUnit) {
		toSerialize["timeUnit"] = o.TimeUnit
	}
	if !IsNil(o.Tactic) {
		toSerialize["tactic"] = o.Tactic
	}
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	return toSerialize, nil
}

type NullableAmazonAdsConnectorFormAllOf struct {
	value *AmazonAdsConnectorFormAllOf
	isSet bool
}

func (v NullableAmazonAdsConnectorFormAllOf) Get() *AmazonAdsConnectorFormAllOf {
	return v.value
}

func (v *NullableAmazonAdsConnectorFormAllOf) Set(val *AmazonAdsConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableAmazonAdsConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableAmazonAdsConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAmazonAdsConnectorFormAllOf(val *AmazonAdsConnectorFormAllOf) *NullableAmazonAdsConnectorFormAllOf {
	return &NullableAmazonAdsConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableAmazonAdsConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAmazonAdsConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
